package kalkulator;

import jakarta.jws.WebService;
import jakarta.xml.ws.Holder;

import java.util.List;

@WebService(endpointInterface = "kalkulator.Kalkulator")
public class KalkulatorImpl implements Kalkulator {
    @Override
    public int sub(int arg1, int arg2) {
        return arg1 - arg2;
    }

    @Override
    public int add(int arg1, int arg2) {
        return arg1 + arg2;
    }

    @Override
    public void div(int arg1, int arg2, Holder<Integer> quotient, Holder<Integer> rest) throws DivZero {
        if(arg2 == 0) {
            throw new DivZero("Dzielenie przez zero!");
        }
        quotient.value = arg1 / arg2;
        rest.value = arg1 % arg2;
    }

    @Override
    public float avg(List<Integer> args) {
        return (float)args.stream().mapToInt(Integer::intValue).average().orElse(0);
    }

    @Override
    public String witaj(String imie) {
        return "Witaj " + imie;
    }

    @Override
    public int mul(int arg1, int arg2) {
        return arg1 * arg2;
    }
}
