package walidacja;

import javax.xml.XMLConstants;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

public class WalidujWaluty2 {
    public static void main(String[] args) {
        String plikXML = "waluty_2022.xml";
        String plikXSD = "waluty.xsd";
        System.out.println("Początek programu");

        try {
            SchemaFactory sf = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
            Schema schema = sf.newSchema(new StreamSource(plikXSD));
            Validator validator = schema.newValidator();
            MojErrorHandler errorHandler = new MojErrorHandler();
            validator.setErrorHandler(errorHandler);
            // Teraz w przypadku błędu walidacji nie będzie wyjątku, tylko zostanie wywłana metoda z przekazanego errorHandlera.

            System.out.println("Start walidacji");
            validator.validate(new StreamSource(plikXML));

            if(errorHandler.czyBylBlad()) {
                System.out.println("Koniec walidacji. Dokument zawierał błędy");
            } else {
                System.out.println("Koniec walidacji. Dokument prawidłowy");
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
